/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	TRUE		1
#define	FALSE		0

unsigned	char	block[16][16];
unsigned	char	buffer422[1920 * 1088 * 2];

int main(int argc, char **argv)
{
	FILE	*fpout;
	int	x, y, index = 0;
	unsigned int	horz = 1920;
	unsigned int	vert = 1080;
	double	xf, yf;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if((y % 64) == 0 || (x % 64) == 0 || ((y - 1) % 64) == 0 || ((x - 1) % 64) == 0)  {
				buffer422[index++] = 0x80;
				buffer422[index++] = 235;
			}
			else  {
				buffer422[index++] = 0x80;
				buffer422[index++] = 0x10;
			}
		}
	}

	for(x = -192; x <= 192; x++)  {
		xf = x;
		yf = sqrt((double)(36864.0 - (xf * xf)));
		y = yf;
		index = ((1920 * 2 * 192) + 385) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 385) + (x * 2) - ((y + 1) * 1920 * 2);
		if(index >= 0)
			buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 385) + (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 385) + (x * 2) + ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
	}
	for(y = -192; y <= 192; y++)  {
		yf = y;
		xf = sqrt((double)(36864.0 - (yf * yf)));
		x = xf;
		index = ((1920 * 2 * 192) + 385) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 385) + (x * 2) - (y * 1920 * 2) + 2;
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 385) - (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 385) - (x * 2) + (y * 1920 * 2) - 2;
		buffer422[index] = 235;
	}

	for(x = -192; x <= 192; x++)  {
		xf = x;
		yf = sqrt((double)(36864.0 - (xf * xf)));
		y = yf;
		index = ((1920 * 2 * 192) + 3457) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 3457) + (x * 2) - ((y + 1) * 1920 * 2);
		if(index >= 0)
			buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 3457) + (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 3457) + (x * 2) + ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
	}
	for(y = -192; y <= 192; y++)  {
		yf = y;
		xf = sqrt((double)(36864.0 - (yf * yf)));
		x = xf;
		index = ((1920 * 2 * 192) + 3457) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 3457) + (x * 2) - (y * 1920 * 2) + 2;
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 3457) - (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 192) + 3457) - (x * 2) + (y * 1920 * 2) - 2;
		buffer422[index] = 235;
	}

	for(x = -192; x <= 192; x++)  {
		xf = x;
		yf = sqrt((double)(36864.0 - (xf * xf)));
		y = yf;
		index = ((1920 * 2 * 888) + 385) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 385) + (x * 2) - ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 385) + (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 385) + (x * 2) + ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
	}
	for(y = -192; y <= 192; y++)  {
		yf = y;
		xf = sqrt((double)(36864.0 - (yf * yf)));
		x = xf;
		index = ((1920 * 2 * 888) + 385) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 385) + (x * 2) - (y * 1920 * 2) + 2;
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 385) - (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 385) - (x * 2) + (y * 1920 * 2) - 2;
		buffer422[index] = 235;
	}

	for(x = -192; x <= 192; x++)  {
		xf = x;
		yf = sqrt((double)(36864.0 - (xf * xf)));
		y = yf;
		index = ((1920 * 2 * 888) + 3457) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 3457) + (x * 2) - ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 3457) + (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 3457) + (x * 2) + ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
	}
	for(y = -192; y <= 192; y++)  {
		yf = y;
		xf = sqrt((double)(36864.0 - (yf * yf)));
		x = xf;
		index = ((1920 * 2 * 888) + 3457) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 3457) + (x * 2) - (y * 1920 * 2) + 2;
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 3457) - (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 888) + 3457) - (x * 2) + (y * 1920 * 2) - 2;
		buffer422[index] = 235;
	}

	for(x = -320; x <= 320; x++)  {
		xf = x;
		yf = sqrt((double)(102400.0 - (xf * xf)));
		y = yf;
		index = ((1920 * 2 * 540) + 1921) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 540) + 1921) + (x * 2) - ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 540) + 1921) + (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 540) + 1921) + (x * 2) + ((y + 1) * 1920 * 2);
		buffer422[index] = 235;
	}
	for(y = -320; y <= 320; y++)  {
		yf = y;
		xf = sqrt((double)(102400.0 - (yf * yf)));
		x = xf;
		index = ((1920 * 2 * 540) + 1921) + (x * 2) - (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 540) + 1921) + (x * 2) - (y * 1920 * 2) + 2;
		buffer422[index] = 235;
		index = ((1920 * 2 * 540) + 1921) - (x * 2) + (y * 1920 * 2);
		buffer422[index] = 235;
		index = ((1920 * 2 * 540) + 1921) - (x * 2) + (y * 1920 * 2) - 2;
		buffer422[index] = 235;
	}

	fwrite(&buffer422[0], 1, horz * vert * 2, fpout);
	fclose(fpout);
	return 0;
}
