/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	TRUE		1
#define	FALSE		0

unsigned	char	block[16][16];
unsigned	char	buffer422[1920 * 1088 * 2];

int Inverse_Table_6_9[8][4] =
{
  {117504, 138453, 13954, 34903}, /* no sequence_display_extension */
  {117504, 138453, 13954, 34903}, /* ITU-R Rec. 709 (1990) */
  {104597, 132201, 25675, 53279}, /* unspecified */
  {104597, 132201, 25675, 53279}, /* reserved */
  {104448, 132798, 24759, 53109}, /* FCC */
  {104597, 132201, 25675, 53279}, /* ITU-R Rec. 624-4 System B, G */
  {104597, 132201, 25675, 53279}, /* SMPTE 170M */
  {117579, 136230, 16907, 35559}  /* SMPTE 240M (1987) */
};

int main(int argc, char **argv)
{
	FILE	*fpout;
	int	x, y, i, j, index = 0;
	unsigned int	horz = 1920;
	unsigned int	vert = 1080;
	unsigned char	luma, cb, cr;
	int	r32, g32, b32;
	int	y32, u32, v32;
	int	crv, cbu, cgu, cgv;
	int	matrix_coefficients = 1;

	if (argc != 3) {
		fprintf(stderr, "usage: crop<outfile> <Y>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(y == 0 || y == 1079)  {
				if (x < 696 || x >= 1224)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else if (x >= 712 && x < 1208)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else  {
					buffer422[index++] = 128;
					buffer422[index++] = 82;
				}
			}
			else if(y == 1 || y == 1078)  {
				if (x < 696 || x >= 1224)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else if (x >= 728 && x < 1192)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else  {
					buffer422[index++] = 128;
					buffer422[index++] = 82;
				}
			}

			else if((y == 2 || y == 1077) && (x >= 744 && x < 1176))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 3 || y == 1076) && (x >= 760 && x < 1160))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 4 || y == 1075) && (x >= 776 && x < 1144))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 5 || y == 1074) && (x >= 792 && x < 1128))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 6 || y == 1073) && (x >= 808 && x < 1112))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 7 || y == 1072) && (x >= 824 && x < 1096))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 8 || y == 1071) && (x >= 840 && x < 1080))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 9 || y == 1070) && (x >= 856 && x < 1064))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 10 || y == 1069) && (x >= 872 && x < 1048))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 11 || y == 1068) && (x >= 888 && x < 1032))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 12 || y == 1067) && (x >= 904 && x < 1016))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 13 || y == 1066) && (x >= 920 && x < 1000))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 14 || y == 1065) && (x >= 936 && x < 984))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 15 || y == 1064) && (x >= 952 && x < 968))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}

			else if(x == 0 || x == 1919)  {
				if (y < 276 || y >= 804)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else if (y >= 292 && y < 788)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else  {
					buffer422[index++] = 128;
					buffer422[index++] = 82;
				}
			}
			else if(x == 1 || x == 1918)  {
				if (y < 276 || y >= 804)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else if (y >= 308 && y < 772)  {
					buffer422[index++] = 128;
					buffer422[index++] = 235;
				}
				else  {
					buffer422[index++] = 128;
					buffer422[index++] = 82;
				}
			}

			else if((x == 2 || x == 1917) && (y >= 324 && y < 756))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 3 || x == 1916) && (y >= 340 && y < 740))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 4 || x == 1915) && (y >= 356 && y < 724))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 5 || x == 1914) && (y >= 372 && y < 708))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 6 || x == 1913) && (y >= 388 && y < 692))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 7 || x == 1912) && (y >= 404 && y < 676))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 8 || x == 1911) && (y >= 420 && y < 660))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 9 || x == 1910) && (y >= 436 && y < 644))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 10 || x == 1909) && (y >= 452 && y < 628))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 11 || x == 1908) && (y >= 468 && y < 612))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 12 || x == 1907) && (y >= 484 && y < 596))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 13 || x == 1906) && (y >= 500 && y < 580))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 14 || x == 1905) && (y >= 516 && y < 564))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 15 || x == 1904) && (y >= 532 && y < 548))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}

			else if((y == 27 || y == 28 || y == 1051 || y == 1052) && (x >= 48 && x <= 1871))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 48 || x == 49 || x == 1870 || x == 1871) && (y >= 27 && y <= 1052))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((y == 54 || y == 55 || y == 1024 || y == 1025) && (x >= 96 && x <= 1823))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else if((x == 96 || x == 97 || x == 1822 || x == 1823) && (y >= 54 && y <= 1025))  {
				buffer422[index++] = 128;
				buffer422[index++] = 235;
			}
			else  {
				buffer422[index++] = 128;
				buffer422[index++] = 82;
			}
		}
	}
	crv = Inverse_Table_6_9[matrix_coefficients][0];
	cbu = Inverse_Table_6_9[matrix_coefficients][1];
	cgu = Inverse_Table_6_9[matrix_coefficients][2];
	cgv = Inverse_Table_6_9[matrix_coefficients][3];
	index = 0;
	luma = atoi(argv[2]);
	if (luma > 128)
		luma++;
	cr = 15;
	cb = 15;
	for(j = 0; j < 1080; j++)  {
		if(j >= 90 && j < 990)  {
			cb = 15;
			if((j % 4) == 0)
				cr++;
			for(i = 0; i < 30; i++)  {
				index = index + 4;
			}
			for(i = 0; i < 900; i++)  {
				if((i % 4) == 0)
					cb++;
				u32 = cb - 128;
				v32 = cr - 128;
				y32 = 76309 * (luma - 16);
				r32 = (y32 + crv*v32 + 32768)>>16;
				g32 = (y32 - cgu*u32 - cgv*v32 + 32768)>>16;
				b32 = (y32 + cbu*u32 + 32786)>>16;

				if ((r32 < 0) || (r32 > 255) || (g32 < 0) || (g32 > 255) || (b32 < 0) || (b32 > 255))
				{
					index = index + 4;
				}
				else  {
					buffer422[index++] = cb;
					buffer422[index++] = luma;
					buffer422[index++] = cr;
					buffer422[index++] = luma;
				}
			}
			for(i = 0; i < 30; i++)  {
				index = index + 4;
			}
		}
		else  {
			index = index + (1920 * 2);
		}
	}
	fwrite(&buffer422[0], 1, horz * vert * 2, fpout);
	fclose(fpout);
	return 0;
}
