/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

int main(int argc, char **argv)
{
	FILE	*fpout;
	unsigned int	i, j, k, luma, markerlo, markerhi;
	unsigned char	y, cb, cr;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(j = 0; j < 270; j++)  {
		markerlo = 0;
		markerhi = 0;
		for(i = 0; i < 1920; i++)  {
			luma = (i * 2) / 15;
			if(luma > 128)
				luma++;
			if(luma == 0)
				luma = 1;
			if(luma >= 255)
				luma = 254;
			if(markerlo < 3 && luma == 16 && (j == 30 || j == 31 || j == 60 || j == 61 || j == 90 || j == 91 || j == 120 || j == 121 || j == 150 || j == 151 || j == 180 || j == 181 || j == 210 || j == 211 || j == 240 || j == 241))
			{
				markerlo++;
				luma = 235;
			}
			if(markerhi < 3 && luma == 236 && (j == 30 || j == 31 || j == 60 || j == 61 || j == 90 || j == 91 || j == 120 || j == 121 || j == 150 || j == 151 || j == 180 || j == 181 || j == 210 || j == 211 || j == 240 || j == 241))
			{
				markerhi++;
				luma = 16;
			}
			y = luma;
			cr = 128;
			cb = 128;
			if((i % 2) == 0)  {
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
			else  {
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
		}
	}
	for(j = 0; j < 270; j++)  {
		for(i = 0; i < 49; i++)  {
			y = 5;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 27;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 38;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 49;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 60;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 71;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 82;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 93;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 104;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 115;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 126;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 137;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 147;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 158;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 169;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 180;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 191;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 202;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 213;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 224;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 235;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 50; i++)  {
			y = 246;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	for(j = 0; j < 270; j++)  {
		for(i = 0; i < 49; i++)  {
			y = 246;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 235;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 224;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 213;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 202;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 191;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 180;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 169;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 158;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 147;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 137;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 126;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 115;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 104;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 93;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 82;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 71;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 60;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 49;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 38;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 27;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 41; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 50; i++)  {
			y = 5;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	for(j = 0; j < 270; j++)  {
		markerlo = 0;
		markerhi = 0;
		for(i = 0, k = 1920; i < 1920; i++, --k)  {
			luma = (k * 2) / 15;
			if(luma > 128)
				luma++;
			if(luma == 0)
				luma = 1;
			if(luma >= 255)
				luma = 254;
			if(markerlo < 3 && luma == 16 && (j == 30 || j == 31 || j == 60 || j == 61 || j == 90 || j == 91 || j == 120 || j == 121 || j == 150 || j == 151 || j == 180 || j == 181 || j == 210 || j == 211 || j == 240 || j == 241))
			{
				markerlo++;
				luma = 235;
			}
			if(markerhi < 3 && luma == 236 && (j == 30 || j == 31 || j == 60 || j == 61 || j == 90 || j == 91 || j == 120 || j == 121 || j == 150 || j == 151 || j == 180 || j == 181 || j == 210 || j == 211 || j == 240 || j == 241))
			{
				markerhi++;
				luma = 16;
			}
			y = luma;
			cr = 128;
			cb = 128;
			if((i % 2) == 0)  {
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
			else  {
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
		}
	}
	fclose(fpout);
	return 0;
}
