/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

unsigned	char	block[16][16];
unsigned	char	buffer422[1920 * 1088 * 2];

int main(int argc, char **argv)
{
	FILE	*fpout;
	int	x, y, index = 0;
	unsigned int	horz = 1920;
	unsigned int	vert = 1080;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 80 && x < 240)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28;
			}
			else if(x >= 400 && x < 560)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51;
			}
			else if(x >= 720 && x < 880)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63;
			}
			else if(x >= 1040 && x < 1200)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133;
			}
			else if(x >= 1360 && x < 1520)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145;
			}
			else if(x >= 1680 && x < 1840)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168;
			}
			else  {
				buffer422[index++] = 128;
				buffer422[index++] = 16;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 141 && x < 240 && y >= 160 && y < 192)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28 + 67;
			}
			else if(x >= 461 && x < 560 && y >= 160 && y < 192)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51 + 67;
			}
			else if(x >= 781 && x < 880 && y >= 160 && y < 192)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63 + 67;
			}
			else if(x >= 1101 && x < 1200 && y >= 160 && y < 192)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133 + 67;
			}
			else if(x >= 1421 && x < 1520 && y >= 160 && y < 192)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145 + 67;
			}
			else if(x >= 1741 && x < 1840 && y >= 160 && y < 192)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168 + 67;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 142 && x < 240 && y >= 288 && y < 320)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28 + 67;
			}
			else if(x >= 462 && x < 560 && y >= 288 && y < 320)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51 + 67;
			}
			else if(x >= 782 && x < 880 && y >= 288 && y < 320)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63 + 67;
			}
			else if(x >= 1102 && x < 1200 && y >= 288 && y < 320)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133 + 67;
			}
			else if(x >= 1422 && x < 1520 && y >= 288 && y < 320)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145 + 67;
			}
			else if(x >= 1742 && x < 1840 && y >= 288 && y < 320)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168 + 67;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 143 && x < 240 && y >= 416 && y < 448)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28 + 67;
			}
			else if(x >= 463 && x < 560 && y >= 416 && y < 448)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51 + 67;
			}
			else if(x >= 783 && x < 880 && y >= 416 && y < 448)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63 + 67;
			}
			else if(x >= 1103 && x < 1200 && y >= 416 && y < 448)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133 + 67;
			}
			else if(x >= 1423 && x < 1520 && y >= 416 && y < 448)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145 + 67;
			}
			else if(x >= 1743 && x < 1840 && y >= 416 && y < 448)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168 + 67;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 544 && y < 576)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28 + 67;
			}
			else if(x >= 464 && x < 560 && y >= 544 && y < 576)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51 + 67;
			}
			else if(x >= 784 && x < 880 && y >= 544 && y < 576)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63 + 67;
			}
			else if(x >= 1104 && x < 1200 && y >= 544 && y < 576)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133 + 67;
			}
			else if(x >= 1424 && x < 1520 && y >= 544 && y < 576)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145 + 67;
			}
			else if(x >= 1744 && x < 1840 && y >= 544 && y < 576)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168 + 67;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 145 && x < 240 && y >= 672 && y < 704)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28 + 67;
			}
			else if(x >= 465 && x < 560 && y >= 672 && y < 704)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51 + 67;
			}
			else if(x >= 785 && x < 880 && y >= 672 && y < 704)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63 + 67;
			}
			else if(x >= 1105 && x < 1200 && y >= 672 && y < 704)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133 + 67;
			}
			else if(x >= 1425 && x < 1520 && y >= 672 && y < 704)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145 + 67;
			}
			else if(x >= 1745 && x < 1840 && y >= 672 && y < 704)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168 + 67;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 146 && x < 240 && y >= 800 && y < 832)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28 + 67;
			}
			else if(x >= 466 && x < 560 && y >= 800 && y < 832)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51 + 67;
			}
			else if(x >= 786 && x < 880 && y >= 800 && y < 832)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63 + 67;
			}
			else if(x >= 1106 && x < 1200 && y >= 800 && y < 832)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133 + 67;
			}
			else if(x >= 1426 && x < 1520 && y >= 800 && y < 832)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145 + 67;
			}
			else if(x >= 1746 && x < 1840 && y >= 800 && y < 832)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168 + 67;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 147 && x < 240 && y >= 928 && y < 960)  {
				buffer422[index++] = 128;
				buffer422[index++] = 28 + 67;
			}
			else if(x >= 467 && x < 560 && y >= 928 && y < 960)  {
				buffer422[index++] = 128;
				buffer422[index++] = 51 + 67;
			}
			else if(x >= 787 && x < 880 && y >= 928 && y < 960)  {
				buffer422[index++] = 128;
				buffer422[index++] = 63 + 67;
			}
			else if(x >= 1107 && x < 1200 && y >= 928 && y < 960)  {
				buffer422[index++] = 128;
				buffer422[index++] = 133 + 67;
			}
			else if(x >= 1427 && x < 1520 && y >= 928 && y < 960)  {
				buffer422[index++] = 128;
				buffer422[index++] = 145 + 67;
			}
			else if(x >= 1747 && x < 1840 && y >= 928 && y < 960)  {
				buffer422[index++] = 128;
				buffer422[index++] = 168 + 67;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	/* chroma */
	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 128 && y < 160)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 212;
				}
				else  {
					buffer422[index++] = 120;
				}
				index++;
			}
			else if(x >= 464 && x < 560 && y >= 128 && y < 160)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 109;
				}
				else  {
					buffer422[index++] = 212;
				}
				index++;
			}
			else if(x >= 784 && x < 880 && y >= 128 && y < 160)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 193;
				}
				else  {
					buffer422[index++] = 204;
				}
				index++;
			}
			else if(x >= 1104 && x < 1200 && y >= 128 && y < 160)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 63;
				}
				else  {
					buffer422[index++] = 52;
				}
				index++;
			}
			else if(x >= 1424 && x < 1520 && y >= 128 && y < 160)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 147;
				}
				else  {
					buffer422[index++] = 44;
				}
				index++;
			}
			else if(x >= 1744 && x < 1840 && y >= 128 && y < 160)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 44;
				}
				else  {
					buffer422[index++] = 136;
				}
				index++;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 256 && y < 288)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 212;
				}
				else  {
					buffer422[index++] = 120;
				}
				index++;
			}
			else if(x >= 464 && x < 560 && y >= 256 && y < 288)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 109;
				}
				else  {
					buffer422[index++] = 212;
				}
				index++;
			}
			else if(x >= 784 && x < 880 && y >= 256 && y < 288)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 193;
				}
				else  {
					buffer422[index++] = 204;
				}
				index++;
			}
			else if(x >= 1104 && x < 1200 && y >= 256 && y < 288)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 63;
				}
				else  {
					buffer422[index++] = 52;
				}
				index++;
			}
			else if(x >= 1424 && x < 1520 && y >= 256 && y < 288)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 147;
				}
				else  {
					buffer422[index++] = 44;
				}
				index++;
			}
			else if(x >= 1744 && x < 1840 && y >= 256 && y < 288)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 44;
				}
				else  {
					buffer422[index++] = 136;
				}
				index++;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 384 && y < 416)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 212;
				}
				else  {
					buffer422[index++] = 120;
				}
				index++;
			}
			else if(x >= 464 && x < 560 && y >= 384 && y < 416)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 109;
				}
				else  {
					buffer422[index++] = 212;
				}
				index++;
			}
			else if(x >= 784 && x < 880 && y >= 384 && y < 416)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 193;
				}
				else  {
					buffer422[index++] = 204;
				}
				index++;
			}
			else if(x >= 1104 && x < 1200 && y >= 384 && y < 416)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 63;
				}
				else  {
					buffer422[index++] = 52;
				}
				index++;
			}
			else if(x >= 1424 && x < 1520 && y >= 384 && y < 416)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 147;
				}
				else  {
					buffer422[index++] = 44;
				}
				index++;
			}
			else if(x >= 1744 && x < 1840 && y >= 384 && y < 416)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 44;
				}
				else  {
					buffer422[index++] = 136;
				}
				index++;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 512 && y < 544)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 212;
				}
				else  {
					buffer422[index++] = 120;
				}
				index++;
			}
			else if(x >= 464 && x < 560 && y >= 512 && y < 544)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 109;
				}
				else  {
					buffer422[index++] = 212;
				}
				index++;
			}
			else if(x >= 784 && x < 880 && y >= 512 && y < 544)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 193;
				}
				else  {
					buffer422[index++] = 204;
				}
				index++;
			}
			else if(x >= 1104 && x < 1200 && y >= 512 && y < 544)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 63;
				}
				else  {
					buffer422[index++] = 52;
				}
				index++;
			}
			else if(x >= 1424 && x < 1520 && y >= 512 && y < 544)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 147;
				}
				else  {
					buffer422[index++] = 44;
				}
				index++;
			}
			else if(x >= 1744 && x < 1840 && y >= 512 && y < 544)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 44;
				}
				else  {
					buffer422[index++] = 136;
				}
				index++;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 640 && y < 672)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 212;
				}
				else  {
					buffer422[index++] = 120;
				}
				index++;
			}
			else if(x >= 464 && x < 560 && y >= 640 && y < 672)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 109;
				}
				else  {
					buffer422[index++] = 212;
				}
				index++;
			}
			else if(x >= 784 && x < 880 && y >= 640 && y < 672)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 193;
				}
				else  {
					buffer422[index++] = 204;
				}
				index++;
			}
			else if(x >= 1104 && x < 1200 && y >= 640 && y < 672)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 63;
				}
				else  {
					buffer422[index++] = 52;
				}
				index++;
			}
			else if(x >= 1424 && x < 1520 && y >= 640 && y < 672)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 147;
				}
				else  {
					buffer422[index++] = 44;
				}
				index++;
			}
			else if(x >= 1744 && x < 1840 && y >= 640 && y < 672)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 44;
				}
				else  {
					buffer422[index++] = 136;
				}
				index++;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 768 && y < 800)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 212;
				}
				else  {
					buffer422[index++] = 120;
				}
				index++;
			}
			else if(x >= 464 && x < 560 && y >= 768 && y < 800)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 109;
				}
				else  {
					buffer422[index++] = 212;
				}
				index++;
			}
			else if(x >= 784 && x < 880 && y >= 768 && y < 800)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 193;
				}
				else  {
					buffer422[index++] = 204;
				}
				index++;
			}
			else if(x >= 1104 && x < 1200 && y >= 768 && y < 800)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 63;
				}
				else  {
					buffer422[index++] = 52;
				}
				index++;
			}
			else if(x >= 1424 && x < 1520 && y >= 768 && y < 800)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 147;
				}
				else  {
					buffer422[index++] = 44;
				}
				index++;
			}
			else if(x >= 1744 && x < 1840 && y >= 768 && y < 800)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 44;
				}
				else  {
					buffer422[index++] = 136;
				}
				index++;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	index = 0;
	for(y = 0; y < vert; y++)  {
		for(x = 0; x < horz; x++)  {
			if(x >= 144 && x < 240 && y >= 896 && y < 928)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 212;
				}
				else  {
					buffer422[index++] = 120;
				}
				index++;
			}
			else if(x >= 464 && x < 560 && y >= 896 && y < 928)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 109;
				}
				else  {
					buffer422[index++] = 212;
				}
				index++;
			}
			else if(x >= 784 && x < 880 && y >= 896 && y < 928)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 193;
				}
				else  {
					buffer422[index++] = 204;
				}
				index++;
			}
			else if(x >= 1104 && x < 1200 && y >= 896 && y < 928)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 63;
				}
				else  {
					buffer422[index++] = 52;
				}
				index++;
			}
			else if(x >= 1424 && x < 1520 && y >= 896 && y < 928)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 147;
				}
				else  {
					buffer422[index++] = 44;
				}
				index++;
			}
			else if(x >= 1744 && x < 1840 && y >= 896 && y < 928)  {
				if(x % 2 == 0)  {
					buffer422[index++] = 44;
				}
				else  {
					buffer422[index++] = 136;
				}
				index++;
			}
			else  {
				index++;
				index++;
			}
		}
	}

	fwrite(&buffer422[0], 1, horz * vert * 2, fpout);
	fclose(fpout);
	return 0;
}
